﻿Imports System.Data.Objects

Module Module1

    Sub Main()
        DeleteAll()
        '       CreateData()
        QueryByLinq()
        '        QueryByEntitySql()
        '        QueryByQueryBuilder()

    End Sub


    Private Sub CreateData()
        Using container As New AddressBookContainer()
            Dim entry1 As New Entry() With
                {
                    .Name = "Doi",
                    .Age = 30,
                    .TelNo = "03-0000-0000",
                    .MailAddress = "doi@hogehoge.com"
                } '1. Entryエンティティを作成
            Dim entry2 As New Entry() With
                {
                    .Name = "Tanaka",
                    .Age = 31,
                    .TelNo = "043-000-0000",
                    .MailAddress = "tanaka@hoge.com"
                }

            Dim category1 As New Category() With
                {
                    .CategoryName = "友達"
                } '2. Categoryエンティティを作成
            Dim category2 As New Category() With
                {
            .CategoryName = "仕事"
                }
            Dim category3 As New Category() With
                {
            .CategoryName = "頻繁に連絡"
                }

            entry1.Categories.Add(category1) '3. EntryエンティティにCategoryエンティティを追加
            entry1.Categories.Add(category3)
            entry2.Categories.Add(category2)
            entry2.Categories.Add(category3)

            container.AddToEntries(entry1) '4. Entryエンティティをデータベースに追加
            container.AddToEntries(entry2)
            container.SaveChanges() '5. 変更内容を保存

        End Using
    End Sub

    Private Sub QueryByLinq()
        Using container As New AddressBookContainer() '1. オブジェクトコンテキストの生成
            'container.ContextOptions.LazyLoadingEnabled = False
            Dim name = "Doi"
            Dim entries = From entry In container.Entries Where entry.Name = name Select entry '2. LINQ to Entitiesでクエリを実行
            PrintEntries(entries) '3.クエリ結果を表示する
        End Using
    End Sub

    Private Sub QueryByEntitySql()
        Using container As New AddressBookContainer() '1. オブジェクトコンテキストの生成
            Dim query = "SELECT VALUE a FROM AddressBookContainer.Entries AS a WHERE a.Name = @name" '2. Entity SQL文字列の設定
            Dim parameters(1) As System.Data.Objects.ObjectParameter '3. Entity SQLに与えるパラメータの設定
            parameters(0) = New System.Data.Objects.ObjectParameter("Name", "Doi")
            Dim entries = container.CreateQuery(Of Entry)(query, parameters) '4. CreateQueryメソッドでクエリを呼び出す
            PrintEntries(entries) '5. クエリ結果を表示する
        End Using
    End Sub

    Private Sub QueryByQueryBuilder()
        Using container As New AddressBookContainer() '1. オブジェクトコンテキストの生成
            Dim entries = container.Entries.Where("it.Age > @age", New ObjectParameter("age", 20)) '2. Query builderのWhereメソッドを呼び出す
            PrintEntries(entries) '3. クエリ結果を表示する
        End Using
    End Sub

    Private Sub PrintEntries(ByVal entries As IQueryable(Of Entry))
        For Each entry In entries '6. 取得したエントリを順に表示する
            Console.WriteLine(String.Format("{0} {1}歳 電話番号:{2}", entry.Name, entry.Age, entry.TelNo))
            'entry.Categories.Load()
            For Each cat In entry.Categories '7. エントリに関連づけられたカテゴリも表示する
                Console.WriteLine(String.Format(" カテゴリ名:{0}", cat.CategoryName))
            Next
        Next
    End Sub

    Private Sub DeleteAll()
        Using container As New AddressBookContainer() '1. オブジェクトコンテキストの生成
            container.ExecuteStoreCommand("DELETE from EntryCategory;") '2. ネイティブSQLによるデータの削除
            container.ExecuteStoreCommand("DELETE from Entries;")
            container.ExecuteStoreCommand("DELETE from Categories;")
        End Using
    End Sub

End Module
